SystemOrganization addCategory: #TreeMap!

MOLayout subclass: #NicoTreeMap
	instanceVariableNames: 'weights relations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TreeMap'!

!NicoTreeMap methodsFor: 'hook' stamp: 'NicolasPinilla 12/22/2011 00:31'!
computePositionsFor: nodes
	| coord parent  counter sibling |
	coord := (0@0).
	nodes first translateTo: coord.
	nodes do: [:n | coord := n origin. 
		((relations select: [ :assoc | assoc key = n model ]) collect: #value) do: [:model | nodes do: 
			[:no | (model = no model) ifTrue: 
				[no translateTo: coord . coord := coord + ((no attributeAt: #treeMapWeight) floor  @ coord y)]]]]! !

!NicoTreeMap methodsFor: 'hook' stamp: 'NicolasPinilla 12/21/2011 21:14'!
computeWeightFor: nodes
	| newWeight bool |
	bool := false.
	nodes do: [:n |
		newWeight := 0.
		relations do: [:rel | 
			(n model = rel key) ifTrue:
				[weights do: [:w | (rel value = w key) ifTrue: [newWeight := newWeight + w value]]]].
		(newWeight ~= 0) ifTrue: 
			[weights do: [:w | (n model = w key) ifTrue: [
					(w value ~= newWeight) ifTrue: [bool := true].
					w value: newWeight]]]].
	bool ifTrue: [bool := false. self computeWeightFor: nodes].
	nodes do: [:n |
		weights do: [:w | 
			(n model = w key) ifTrue: [n attributeAt: #treeMapWeight put: w value sqrt]]]! !

!NicoTreeMap methodsFor: 'hook' stamp: 'NicolasPinilla 12/21/2011 23:07'!
doExecute: aGraphElement
	
	"1 - Compute the weight of each node using the relations 
	 2 - Position the nodes according to their weight"
	self computeWeightFor: aGraphElement nodes.
	self computePositionsFor: aGraphElement nodes.
	self setSizeFor: aGraphElement nodes.! !

!NicoTreeMap methodsFor: 'accessing' stamp: 'NicolasPinilla 12/15/2011 15:32'!
relations
	^ relations! !

!NicoTreeMap methodsFor: 'accessing' stamp: 'NicolasPinilla 12/15/2011 15:32'!
relations: anObject
	relations := anObject! !

!NicoTreeMap methodsFor: 'hook' stamp: 'NicolasPinilla 12/21/2011 11:59'!
setSizeFor: nodes
	nodes do: [:n | n setBoundsTo: (n position extent: (n attributeAt: #treeMapWeight) @ (n attributeAt: #treeMapWeight))].! !

!NicoTreeMap methodsFor: 'accessing' stamp: 'NicolasPinilla 12/15/2011 15:32'!
weights
	^ weights! !

!NicoTreeMap methodsFor: 'accessing' stamp: 'NicolasPinilla 12/15/2011 15:32'!
weights: anObject
	weights := anObject! !

MONode subclass: #TMNode
	instanceVariableNames: 'weight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TreeMap'!

TMNode subclass: #Inner
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TreeMap'!

!Inner methodsFor: 'as yet unclassified' stamp: 'NicolasPinilla 12/15/2011 14:11'!
addChildren: aNode
	children add: aNode! !

!Inner methodsFor: 'as yet unclassified' stamp: 'NicolasPinilla 12/15/2011 14:36'!
checkSumWeight 
	| childrenWeight bool |
	childrenWeight := 0.
	bool := true.
	children do: [:node | childrenWeight := childrenWeight + node weight ].
	children do: [:node | bool := bool and: node checkSumWeight ].
	^ (self weight = childrenWeight) and: bool! !

!Inner methodsFor: 'accessing' stamp: 'NicolasPinilla 12/15/2011 14:10'!
children
	^children! !

!Inner methodsFor: 'initialization' stamp: 'NicolasPinilla 12/15/2011 14:12'!
initialize 
	super initialize.
	children := OrderedCollection new.! !

!Inner methodsFor: 'as yet unclassified' stamp: 'NicolasPinilla 12/15/2011 14:31'!
sumWeight
	| childrenWeight |
	childrenWeight := 0.
	children do: [:node | childrenWeight := childrenWeight + node sumWeight ]. 
	^ self weight + childrenWeight! !

TMNode subclass: #Leaf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TreeMap'!

!Leaf methodsFor: 'as yet unclassified' stamp: 'NicolasPinilla 12/15/2011 00:14'!
checkSumWeight 
	^true! !

!Leaf methodsFor: 'initialization' stamp: 'NicolasPinilla 12/14/2011 23:53'!
initialize 
	super initialize.! !

!Leaf methodsFor: 'as yet unclassified' stamp: 'NicolasPinilla 12/15/2011 00:15'!
sumWeight 
	^ self weight! !

!TMNode methodsFor: 'as yet unclassified' stamp: 'NicolasPinilla 12/15/2011 00:01'!
checkSumWeight! !

!TMNode methodsFor: 'as yet unclassified' stamp: 'NicolasPinilla 12/14/2011 23:52'!
initialize
	super initialize.
	weight := 0.! !

!TMNode methodsFor: 'as yet unclassified' stamp: 'NicolasPinilla 12/15/2011 00:14'!
sumWeight! !

!TMNode methodsFor: 'accessing' stamp: 'NicolasPinilla 12/14/2011 14:40'!
weight
	^weight! !

!TMNode methodsFor: 'accessing' stamp: 'NicolasPinilla 12/14/2011 01:37'!
weight: aNumber
	weight := aNumber! !

TestCase subclass: #TestTreeMap
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TreeMap'!

!TestTreeMap methodsFor: 'as yet unclassified' stamp: 'NicolasPinilla 12/22/2011 00:47'!
testTreeMap

	| weights view nodes nodeB nodeC |
	view := MOViewRenderer new.
	weights := {#a -> 1 . #b -> 600 . #c -> 1000 . #d -> 500 . #e -> 1200}.
	nodes := view nodes: #(#a #b #c #d #e).
	view layout: (NicoTreeMap new
					weights: weights;
					relations: {#a -> #b . #a -> #c . #b -> #d . #b -> #e} ).
	
	view root applyLayout.
	
	nodeB := (nodes select: [:n | n model = #b]) first.
	nodeC := (nodes select: [:n | n model = #c]) first.
	self assert: (nodes first model == #a).
	self assert: (nodes first hasAttribute: #treeMapWeight).
	self assert: (nodes first attributeAt: #treeMapWeight) = 2700 sqrt.
	self assert: (nodeC origin = (nodeB origin + ((nodeB attributeAt: #treeMapWeight) floor @ 0)))! !

TestCase subclass: #TestTreeMapOLD
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TreeMap'!

!TestTreeMapOLD methodsFor: 'as yet unclassified' stamp: 'NicolasPinilla 12/15/2011 14:39'!
setUp
	| child1 child2 child3 child11 child12 |
	node := Inner new.
	child1 := Inner new.
	child2 := Leaf new.
	child3 := Leaf new.
	child11 := Leaf new.
	child12 := Leaf new.
	node weight: 12.
	child1 weight: 5.
	child2 weight: 3.
	child3 weight: 4.
	child11 weight: 2.
	child12 weight: 3.
	child1 addChildren: child11.
	child1 addChildren: child12.
	node addChildren: child1;
	addChildren: child2;
	addChildren: child3.! !

!TestTreeMapOLD methodsFor: 'as yet unclassified' stamp: 'NicolasPinilla 12/14/2011 14:54'!
testCheckSumWeight
	self assert: (node checkSumWeight)
	! !

!TestTreeMapOLD methodsFor: 'as yet unclassified' stamp: 'NicolasPinilla 12/15/2011 14:27'!
testSumWeight
	self assert: (node sumWeight = 29)
	! !
